using System;
using System.Data.Entity.ModelConfiguration;
using System.Data.Common;
using System.Data.Entity;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using SchoolModelCreateByPowerTools.Entities;

namespace SchoolModelCreateByPowerTools.Mapping
{
	public class DepartmentMap : EntityTypeConfiguration<Department>
	{
		public DepartmentMap()
		{
			// Primary Key
			this.HasKey(t => t.DepartmentID);

			// Properties
			this.Property(t => t.DepartmentID)
				.HasDatabaseGeneratedOption(DatabaseGeneratedOption.None);
				
			this.Property(t => t.Name)
				.IsRequired()
				.HasMaxLength(50);
				
			// Table & Column Mappings
			this.ToTable("Department");
			this.Property(t => t.DepartmentID).HasColumnName("DepartmentID");
			this.Property(t => t.Name).HasColumnName("Name");
			this.Property(t => t.Budget).HasColumnName("Budget");
			this.Property(t => t.StartDate).HasColumnName("StartDate");
			this.Property(t => t.Administrator).HasColumnName("Administrator");
		}
	}
}

