using System;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using SchoolModelCreateByPowerTools.Entities;
using SchoolModelCreateByPowerTools.Mapping;

namespace SchoolModelCreateByPowerTools
{
	public class SchoolContext : DbContext
	{
		static SchoolContext()
		{ 
			Database.SetInitializer<SchoolContext>(null);
		}

		public DbSet<Course> Courses { get; set; }
		public DbSet<Department> Departments { get; set; }
		public DbSet<OfficeAssignment> OfficeAssignments { get; set; }
		public DbSet<OnlineCourse> OnlineCourses { get; set; }
		public DbSet<OnsiteCourse> OnsiteCourses { get; set; }
		public DbSet<Person> People { get; set; }
		public DbSet<StudentGrade> StudentGrades { get; set; }
		public DbSet<sysdiagram> sysdiagrams { get; set; }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
		{
            modelBuilder.Conventions.Remove<IncludeMetadataConvention>();
			modelBuilder.Configurations.Add(new CourseMap());
			modelBuilder.Configurations.Add(new DepartmentMap());
			modelBuilder.Configurations.Add(new OfficeAssignmentMap());
			modelBuilder.Configurations.Add(new OnlineCourseMap());
			modelBuilder.Configurations.Add(new OnsiteCourseMap());
			modelBuilder.Configurations.Add(new PersonMap());
			modelBuilder.Configurations.Add(new StudentGradeMap());
			modelBuilder.Configurations.Add(new sysdiagramMap());
		}
	}
}

